## libgnatcoll-db 21.0.0

=== gnatcoll_db2ada/Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   DB_BACKEND    : either db (no backend), sqlite, postgres or all
#                   (all available backends)

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

DB_BACKEND=db

NAME=gnatcoll_$(DB_BACKEND)2ada

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=$(NAME).gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/$(NAME).gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/../version_information)

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =

all: build

# Load current setup if any
-include makefile.setup

NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

GTARGET=--target=$(NORMALIZED_TARGET)

GPR_VARS= \
	 -XLIBRARY_TYPE=static \
	 -XXMLADA_BUILD=static \
	 -XGPR_BUILD=static \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f --target=$(TARGET) $(GPR_VARS) \
	$(RBD) --mode=usage --no-project --sources-subdir=include/$(NAME) --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(GPR_VARS) $(RBD)
UNINSTALLER=$(INSTALLER) -p -f --install-name=$(NAME) --uninstall

#########
# build #
#########

build:
	$(BUILDER) $(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/$(NAME)))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall
	$(INSTALLER) $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean:
	-$(CLEANER) $(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup
	$(ECHO) "DB_BACKEND=$(DB_BACKEND)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== debian/changelog ===
libgnatcoll-db (21.0.0-6) unstable; urgency=medium

  [ Peter Michael Green ]
  * Use -Os on mipsel, to work around jump length error (Closes: 971018).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 29 Dec 2020 17:08:02 +0000

libgnatcoll-db (21.0.0-5) unstable; urgency=medium

  [ Adrian Bunk <bunk@debian.org> ]
  * Fix the build on mipsel.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 22 Dec 2020 23:35:21 +0100

libgnatcoll-db (21.0.0-4) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 21 Dec 2020 07:50:30 +0100

libgnatcoll-db (21.0.0-3) experimental; urgency=medium

  * Let -db-bin Break and Replace -sqlite-bin. Closes: #975006.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 17 Nov 2020 21:09:31 +0000

libgnatcoll-db (21.0.0-2) experimental; urgency=medium

  * Clean xref/generated/* but keep the directory for a future build.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 17 Nov 2020 18:34:58 +0000

libgnatcoll-db (21.0.0-1) experimental; urgency=medium

  * New upstream release.  New -doc package.
    No ALI/SO change in experimental, but the version restrictions in
    build dependencies  should ensure the build order.
  * Upstream now grants the GCC runtime exception to GPL-3+.
    Relicense Debian packaging accordingly.
  * Debian now accepts code linking GPL code with OpenSSL.
    Reenable binding to PostGreSQL (closes: #868189).
    Rename helper executable and -bin package for consistency.
  * Upstream recommends to watch github instead of the community website.
    The main motivation for repackaging has disappeared.
    Restore license for previously stripped sqlite/amalgamation copy.
  * Revert an upstream commit (subsecond precision in SQLite timestamps)
    requiring gnat features not yet in Debian.
  * Adapt doc build script to python3.
  * Remove unused sphinx extensions.
  * Improve description of binary packages.
  * Change global Section from misc to more accurate libdevel.
  * Replace generic description of gnatcoll with specific descriptions.
  * Improve patch introducing a shared GNAT project (no-op for Debian, but
    may help acceptance by upstream).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 15 Nov 2020 20:56:43 +0000

libgnatcoll-db (20.0-1) experimental; urgency=medium

  * New upstream release built with gnat-10. Rename lib and -dev packages.
  * Split some patches and forward some.
  * Debhelper 13.
  * Drop obsolete Pre-Depends.
  * Pass build flags via the environment.
  * Spare some gprbuild runs.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 07 Jun 2020 19:48:22 +0000

=== debian/control ===
Source: libgnatcoll-db
Priority: optional
Section: libdevel
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 dh-ada-library (>= 7.2),
 dh-sequence-ada-library,
 gnat,
# debian/rules finds the gnat version here:
 gnat-10,
 gprbuild (>= 2021.0.0.0778b109-2),
 libgnatcoll19-dev (>= 21.0.0-2),
 libgnatcoll-iconv19-dev (>= 21.0.0-3),
 libpq-dev,
 libsqlite3-dev,
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
# Sphinx >= 1.6 uses the latexmk driver:
 latexmk,
 python3-sphinx,
 sphinx-common,
 texlive-fonts-recommended,
 texlive-latex-extra,
Homepage: https://github.com/AdaCore/gnatcoll-db
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll-db
Vcs-Git: https://salsa.debian.org/debian/libgnatcoll-db.git

######################################################################

Package: libgnatcoll-sqlite19-dev
Architecture: any
Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
Description: Ada library accessing SQLite databases
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the static library and Ada specifications
 dedicated to SQLite databases manipulation.

Package: libgnatcoll-sqlite20
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada library accessing SQLite databases (runtime)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the runtime shared library for the SQLite
 backend.


######################################################################

Package: libgnatcoll-db-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: Ada library accessing SQL databases (documentation)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libgnatcoll-db-bin
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libgnatcoll-db-doc,
Breaks: libgnatcoll-sqlite-bin
Replaces: libgnatcoll-sqlite-bin
Description: Ada library accessing SQL databases (tools)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains command-line tools.
 * gnatcoll_db2ada generates Ada sources depending on
   libngatcoll-sqlite or libgnatcoll-postgres.
 * gnatinspect runs in a source tree and generate a database of
   cross-references.

######################################################################

Package: libgnatcoll-sql3-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
Description: Ada library accessing SQL databases
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the static library and Ada specifications of
 the backend-independant part.

Package: libgnatcoll-sql3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada library accessing SQL databases (runtime)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the runtime shared library of the
 backend-independant part.

######################################################################

Package: libgnatcoll-xref20-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
Description: Ada library for manipulation of Ada cross references
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the static library and Ada specifications for
 the XRef module, which builds a database of cross references from a
 source tree.

Package: libgnatcoll-xref20
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada library for manipulation of Ada cross references (runtime)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the runtime shared library for the XRef module,
 which builds a database of cross references from a source tree.

######################################################################

Package: libgnatcoll-postgres1-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
Description: Ada library accessing PostGreSQL databases
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the static library and Ada specifications
 dedicated to PostGreSQL databases manipulation.

Package: libgnatcoll-postgres1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada library accessing PostGreSQL databases (runtime)
 The gnatcoll-db library allows Ada programs to send SQL queries to
 SQLite or PostGreSQL databases.
 .
 This package contains the runtime shared library for the PostGreSQL
 backend.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl database components in Debian.
# Copyright (c) 2014-2020 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

$(foreach line,$(shell sed -n '\
  s/^ gnat-\([0-9.]\+\),$$/                          GNAT_VERSION:=\1        /p; \
  s/^Package: libgnatcoll-\([a-z]\+\)\([0-9.]\+\)$$/ gnatcoll_\1_version:=\2 /p; \
  ' debian/control),$(eval $(line)))

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined

# On mips64el gnatcoll-xref.adb generates long jump that do not fit in
# standard branch instructions. Use the mxgot option to workaround that.
# See bug #953069.
ifneq (,$(filter mips64el,$(DEB_HOST_ARCH)))
  DEB_CFLAGS_MAINT_APPEND := -mxgot
endif

# Use -Os on mipsel to workaround further jump length issues
ifneq (,$(filter mipsel,$(DEB_HOST_ARCH)))
  DEB_CFLAGS_MAINT_APPEND += -Os
endif

include /usr/share/dpkg/buildflags.mk
include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
# wildcard means: not during -indep builds.

LD_LIBRARY_PATH := \
  sql/lib/relocatable:sqlite/lib/relocatable:postgres/lib/relocatable:xref/lib/relocatable
ADA_PROJECT_PATH := $(subst /lib/relocatable,,$(LD_LIBRARY_PATH))
libs := $(subst :, ,$(ADA_PROJECT_PATH))

# The scenario variables passed to gprbuild and dh_ada_library.
GNATCOLL_SQLITE := external
vars := \
  $(foreach l,$(libs),gnatcoll_$(l)_version) \
  GNATCOLL_SQLITE \

gprbuild := \
  ADA_PROJECT_PATH=$(ADA_PROJECT_PATH) \
  gprbuild -p $(BUILDER_OPTIONS) \
  $(foreach v,$(vars),-X$(v)="$($(v))")

%:
	dh $@

# Dependencies and parallelism are handled by gprbuild,
# avoid using Make for this (risky, without much gain).
# Anyway, there is only one possible build order.
# For the same reason, blindly regenerate xref/generated.

.PHONY: override_dh_auto_build-arch
override_dh_auto_build-arch:

	rm -f xref/generated/*

  # Build db2ada (and relocatable sql, postgres, sqlite).
	$(gprbuild) gnatcoll_db2ada/gnatcoll_all2ada.gpr -XLIBRARY_TYPE=relocatable
	cp gnatcoll_db2ada/obj/gnatcoll_all2ada gnatcoll_db2ada/obj/gnatcoll_db2ada

# TODO: ask upstream to provide initialdata.txt and this Makefile
# snippet. They have probably forgotten them during the libgnatcoll
# source package split.
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) \
	  gnatcoll_db2ada/obj/gnatcoll_db2ada \
	  -dbtype=sqlite \
	  -dbname=:memory: \
	  -output xref/generated \
	  -dbmodel=gnatcoll_db2ada/dbschema.txt \
	  -createdb \
	  -adacreate \
	  -api GNATCOLL.Xref.Database \
	  -load=debian/initialdata.txt \
	  -enum "f2f_kind,id,name,F2F,Integer" \
	  -enum "e2e_kind,id,name,E2E,Integer"

  # Build static xref (and sql, sqlite as dependencies).
	$(gprbuild) gnatcoll_xref.gpr           -XLIBRARY_TYPE=static

  # Build static postgres (and sql).
	$(gprbuild) gnatcoll_postgres.gpr       -XLIBRARY_TYPE=static

  # Build gnatinspect (and relocatable sql, sqlite, xref).
	$(gprbuild) gnatinspect/gnatinspect.gpr -XLIBRARY_TYPE=relocatable

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean --sourcedir=docs
	rm -f xref/generated/*
	rm -fr \
	  $(addsuffix /lib,$(libs)) \
	  $(addsuffix /obj,$(libs) gnatcoll_db2ada gnatinspect)

# dh_ada_library does not accept -aP arguments.
.PHONY: override_dh_ada_library
override_dh_ada_library:
	ADA_PROJECT_PATH=$(ADA_PROJECT_PATH) \
	dh_ada_library $(foreach l,$(libs), \
	  LIBRARY_TYPE=relocatable \
	  $(foreach v,$(vars),$(v)="$($(v))") \
	  $(l)/gnatcoll_$(l).gpr)

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --sourcedir=docs -- html latexpdf text
endif

# Avoid a warning about doc-main-package.
doc_pkg := libgnatcoll-db-doc
override_dh_installdocs:
	dh_installdocs --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
	dh_installdocs --remaining-packages
override_dh_installexamples:
	dh_installexamples --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
	dh_installexamples --remaining-packages

=== debian/tests/control ===
Tests: gnatinspect

Tests: link-sqlite
Depends: @, gprbuild

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gnatcoll-db-$1.tar.gz%" \
https://github.com/AdaCore/gnatcoll-db/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## libgnatcoll-db 22.0.0

=== debian/changelog ===
libgnatcoll-db (22.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition
  * Configure branch names for git-buildpackage
  * Require dh-ada-library 7.5, which generates ada:Depends differently

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 May 2022 19:35:17 +0200

libgnatcoll-db (22.0.0-1) experimental; urgency=medium

  * Build new upstream version with gnat-11. Rename -dev packages.
    Force build order in experimental with version restrictions.
  * Build-Depend: tex-gyre.
  * Standards-Version: 4.6.0.
  * Cherry-pick equality-string-unbounded.diff from upstream 22.2 branch.
  * Use unversioned debian_packaging.mk from the gnat package.
  * Add upstream metadata.
  * uscan: drop unneeded filenamemangle option.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 22 Mar 2022 13:27:02 +0000

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,13 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- dh-ada-library (>= 7.2),
+ dh-ada-library (>= 7.5),
  dh-sequence-ada-library,
  gnat,
-# debian/rules finds the gnat version here:
- gnat-10,
+ gnat-11 (>= 11.2.0-19),
  gprbuild (>= 2021.0.0.0778b109-2),
- libgnatcoll19-dev (>= 21.0.0-2),
- libgnatcoll-iconv19-dev (>= 21.0.0-3),
+ libgnatcoll20-dev (>= 22.1.0-2),
+ libgnatcoll-iconv20-dev,
  libpq-dev,
  libsqlite3-dev,
 Build-Depends-Indep:
@@ -21,17 +20,18 @@
  latexmk,
  python3-sphinx,
  sphinx-common,
+ tex-gyre,
  texlive-fonts-recommended,
  texlive-latex-extra,
 Homepage: https://github.com/AdaCore/gnatcoll-db
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll-db
 Vcs-Git: https://salsa.debian.org/debian/libgnatcoll-db.git
 
 ######################################################################
 
-Package: libgnatcoll-sqlite19-dev
+Package: libgnatcoll-sqlite20-dev
 Architecture: any
 Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -89,7 +89,7 @@
 
 ######################################################################
 
-Package: libgnatcoll-sql3-dev
+Package: libgnatcoll-sql4-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -114,7 +114,7 @@
 
 ######################################################################
 
-Package: libgnatcoll-xref20-dev
+Package: libgnatcoll-xref21-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -140,7 +140,7 @@
 
 ######################################################################
 
-Package: libgnatcoll-postgres1-dev
+Package: libgnatcoll-postgres2-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # Build script for GNATColl database components in Debian.
-# Copyright (c) 2014-2020 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2014-2022 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -16,7 +16,6 @@
 # /usr/share/common-licenses/GPL-3.
 
 $(foreach line,$(shell sed -n '\
-  s/^ gnat-\([0-9.]\+\),$$/                          GNAT_VERSION:=\1        /p; \
   s/^Package: libgnatcoll-\([a-z]\+\)\([0-9.]\+\)$$/ gnatcoll_\1_version:=\2 /p; \
   ' debian/control),$(eval $(line)))
 
@@ -39,8 +38,10 @@
   DEB_CFLAGS_MAINT_APPEND += -Os
 endif
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
-include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
+include /usr/share/dpkg/buildopts.mk
+include $(wildcard /usr/share/ada/debian_packaging.mk)
 # wildcard means: not during -indep builds.
 
 LD_LIBRARY_PATH := \
@@ -56,7 +57,7 @@
 
 gprbuild := \
   ADA_PROJECT_PATH=$(ADA_PROJECT_PATH) \
-  gprbuild -p $(BUILDER_OPTIONS) \
+  gprbuild -p $(GPRBUILDFLAGS) \
   $(foreach v,$(vars),-X$(v)="$($(v))")
 
 %:
@@ -119,9 +120,10 @@
 	  $(l)/gnatcoll_$(l).gpr)
 
 override_dh_auto_build-indep:
-ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	dh_auto_build --sourcedir=docs -- html latexpdf text
-endif
+  ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	dh_auto_build --sourcedir=docs -- html latexpdf text \
+	  $(addprefix SPHINXOPTS=-j,$(DEB_BUILD_OPTION_PARALLEL))
+  endif
 
 # Avoid a warning about doc-main-package.
 doc_pkg := libgnatcoll-db-doc

## libgnatcoll-db 23.0.0

=== pgxs/Makefile ===

all: setup
	gprbuild -p -P example/module.gpr -XPG_CONFIG_INCLUDEDIR_SERVER=`pg_config --includedir-server`
	gprbuild -p -P testsuite/module.gpr -XPG_CONFIG_INCLUDEDIR_SERVER=`pg_config --includedir-server`

setup:
	sed "s/@MODULEDIR@/`pwd | sed 's/\\//\\\\\\//g'`\/.libs/" example/module.sql.in > example/module.sql
	sed "s/@MODULEDIR@/`pwd | sed 's/\\//\\\\\\//g'`\/.libs/" testsuite/module.sql.in > testsuite/module.sql

clean:
	rm -rf .objs .libs
	rm -f example/module.sql testsuite/module.sql
	rm -f test_pgxs.output

initdb_ordinary:
	dropdb test || true
	createdb test
	psql test -f testsuite/schema.sql

initdb_super:
	psql test -f example/module.sql
	psql test -f testsuite/module.sql

check:
	psql -q -t test -f testsuite/test_pgxs.sql > test_pgxs.output
	diff -u testsuite/test_pgxs.expected test_pgxs.output
	rm test_pgxs.output

=== debian/changelog ===
libgnatcoll-db (23.0.0-4) unstable; urgency=medium

  * Break/Replace libgnatcoll-*-dev since oldstable.
    Closes: #1034946, #1034964, #1034981, #1035010.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 10 May 2023 23:15:55 +0200

libgnatcoll-db (23.0.0-3) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 01:37:53 +0100

libgnatcoll-db (23.0.0-2) experimental; urgency=medium

  * The flags fixing MIPS builds were relying on a bug in packaging.mk
    (DEB_CFLAGS_MAINT_* influencing ADAFLAGS). Explicitly fix both languages.
  * Revert the part of 23.0.0-1 applying two flags to two architectures.
    This is confusing and does not help.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 21 Dec 2022 15:01:04 +0000

libgnatcoll-db (23.0.0-1) experimental; urgency=medium

  * New upstream version 23.0.0
  * Build-Depend: sphinx rtd theme
  * Standards-Version: 4.6.2
  * Refresh patches
  * Set both -mxgot -Os on both mips64el mipsel

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 21 Dec 2022 14:12:14 +0100

libgnatcoll-db (23~20220814-1) experimental; urgency=medium

  * Update for dh-ada-library 8.1.
  * Upstream snapshot applying some patches.
  * gnatcoll.gpr is now generated by.gprinstall and does define So_Ext,
    remove the related patch.
  * Install executables and libraries to debian/tmp with gprinstall.
  * Avoid dh_auto_build spawning several gprbuild or sphinx,
    interfering with their own job management.
  * Patch adding an informative shebang to installed scripts.
  * Prefer execute_before_dh_before to override/--remaining-packages.
  * Keep upstream layout for the only example.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 29 Aug 2022 22:38:31 +0000

libgnatcoll-db (23~20220527-1) experimental; urgency=medium

  * Build new snapshot with gcc-12 for experimental.
    Rename -dev packages per Ada policy.  No new shared object version.
  * Install example into the -doc package
  * Install dborm.py, required by gnatcoll_db2ada
  * rules: include architecture.mk before using it
  * rules: simplify transmission of versions/paths to gprbuild/dh-ada-library
  * Build with gcc-12 for experimental
  * Ensure the same compiler for Ada and C
  * Prefer debian/clean to a debhelper override
  * Bump Standards-Version
  * Refresh and update patches

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 10 Aug 2022 10:08:40 +0000

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,12 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- dh-ada-library (>= 7.5),
+ dh-ada-library (>= 8.1),
  dh-sequence-ada-library,
- gnat,
- gnat-11 (>= 11.2.0-19),
+ gnat-12,
  gprbuild (>= 2021.0.0.0778b109-2),
- libgnatcoll20-dev (>= 22.1.0-2),
- libgnatcoll-iconv20-dev,
+ libgnatcoll21-dev (>= 22.1.0-2),
+ libgnatcoll-iconv21-dev,
  libpq-dev,
  libsqlite3-dev,
 Build-Depends-Indep:
@@ -19,19 +18,23 @@
 # Sphinx >= 1.6 uses the latexmk driver:
  latexmk,
  python3-sphinx,
+# docs/conf.py
+ python3-sphinx-rtd-theme,
  sphinx-common,
  tex-gyre,
  texlive-fonts-recommended,
  texlive-latex-extra,
 Homepage: https://github.com/AdaCore/gnatcoll-db
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll-db
 Vcs-Git: https://salsa.debian.org/debian/libgnatcoll-db.git
 
 ######################################################################
 
-Package: libgnatcoll-sqlite20-dev
+Package: libgnatcoll-sqlite21-dev
+Breaks: libgnatcoll-sqlite17-dev, libgnatcoll-sqlite18-dev, libgnatcoll-sqlite19-dev, libgnatcoll-sqlite20-dev
+Replaces: libgnatcoll-sqlite17-dev, libgnatcoll-sqlite18-dev, libgnatcoll-sqlite19-dev, libgnatcoll-sqlite20-dev
 Architecture: any
 Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -89,7 +92,9 @@
 
 ######################################################################
 
-Package: libgnatcoll-sql4-dev
+Package: libgnatcoll-sql5-dev
+Breaks: libgnatcoll-sql1-dev, libgnatcoll-sql2-dev, libgnatcoll-sql3-dev, libgnatcoll-sql4-dev
+Replaces: libgnatcoll-sql1-dev, libgnatcoll-sql2-dev, libgnatcoll-sql3-dev, libgnatcoll-sql4-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -114,7 +119,9 @@
 
 ######################################################################
 
-Package: libgnatcoll-xref21-dev
+Package: libgnatcoll-xref22-dev
+Breaks: libgnatcoll-xref18-dev, libgnatcoll-xref19-dev, libgnatcoll-xref20-dev, libgnatcoll-xref21-dev
+Replaces: libgnatcoll-xref18-dev, libgnatcoll-xref19-dev, libgnatcoll-xref20-dev, libgnatcoll-xref21-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,
@@ -140,7 +147,9 @@
 
 ######################################################################
 
-Package: libgnatcoll-postgres2-dev
+Package: libgnatcoll-postgres3-dev
+Breaks: libgnatcoll-postgres1-dev, libgnatcoll-postgres2-dev
+Replaces: libgnatcoll-postgres1-dev, libgnatcoll-postgres2-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-db-bin, libgnatcoll-db-doc,

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl database components in Debian.
# Copyright (c) 2014-2022 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined

include /usr/share/dpkg/architecture.mk

# On mips64el gnatcoll-xref.adb generates long jump that do not fit in
# standard branch instructions. Use the mxgot option to workaround that.
# See bug #953069.
ifeq ($(DEB_HOST_ARCH),mips64el)
  DEB_ADAFLAGS_MAINT_APPEND := -mxgot
  DEB_CFLAGS_MAINT_APPEND := -mxgot
endif

# Use -Os on mipsel to workaround further jump length issues
# See bug #971018.
ifeq ($(DEB_HOST_ARCH),mipsel)
  DEB_ADAFLAGS_MAINT_APPEND := -Os
  DEB_CFLAGS_MAINT_APPEND := -Os
endif

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include $(wildcard /usr/share/ada/packaging.mk)
# wildcard means: not during -indep builds.

# The order matters for dh_ada_library.
libs := sql sqlite postgres xref

gpr_vars := \
  -XGNATCOLL_SQLITE=external \
  $(libs:%=-aP%) \
  -XGNATCOLL_SQL_VERSION=$(gnatcoll_sql_SO_VERSION) \
  -XGNATCOLL_SQLITE_VERSION=$(gnatcoll_sqlite_SO_VERSION) \
  -XGNATCOLL_POSTGRES_VERSION=$(gnatcoll_postgres_SO_VERSION) \
  -XGNATCOLL_XREF_VERSION=$(gnatcoll_xref_SO_VERSION) \
  # EOL

gprbuild := \
  gprbuild -p $(GPRBUILDFLAGS) \
  $(gpr_vars)

%:
	dh $@

# Dependencies and parallelism are handled by gprbuild,
# avoid using Make for this (risky, without much gain).
# Anyway, there is only one possible build order.
# For the same reason, blindly regenerate xref/generated.

.PHONY: override_dh_auto_build-arch
override_dh_auto_build-arch:

  # Ensure the same major version for Ada and C compilers.
	gprconfig --batch $(GPRCONFIGFLAGS)

	rm -f xref/generated/*

  # Build db2ada (and relocatable sql, postgres, sqlite).
	$(gprbuild) gnatcoll_db2ada/gnatcoll_all2ada.gpr -XLIBRARY_TYPE=relocatable

# TODO: ask upstream to provide initialdata.txt and this Makefile
# snippet. They have probably forgotten them during the libgnatcoll
# source package split.
	LD_LIBRARY_PATH=$(subst $() ,:,$(libs:=/lib/relocatable)) \
	  gnatcoll_db2ada/obj/gnatcoll_all2ada \
	  -dbtype=sqlite \
	  -dbname=:memory: \
	  -output xref/generated \
	  -dbmodel=gnatcoll_db2ada/dbschema.txt \
	  -createdb \
	  -adacreate \
	  -api GNATCOLL.Xref.Database \
	  -load=debian/initialdata.txt \
	  -enum "f2f_kind,id,name,F2F,Integer" \
	  -enum "e2e_kind,id,name,E2E,Integer"

  # Build static xref (and sql, sqlite as dependencies).
	$(gprbuild) gnatcoll_xref.gpr           -XLIBRARY_TYPE=static

  # Build static postgres (and sql).
	$(gprbuild) gnatcoll_postgres.gpr       -XLIBRARY_TYPE=static

  # Build gnatinspect (and relocatable sql, sqlite, xref).
	$(gprbuild) gnatinspect/gnatinspect.gpr -XLIBRARY_TYPE=relocatable

override_dh_auto_install-arch: $(libs:%=install-%)
	gprinstall gnatinspect/gnatinspect.gpr $(gpr_vars) \
	  -XLIBRARY_TYPE=relocatable $(standard_GPRINSTALLFLAGS)
	gprinstall gnatcoll_db2ada/gnatcoll_all2ada.gpr $(gpr_vars) \
	  -XLIBRARY_TYPE=relocatable $(standard_GPRINSTALLFLAGS)
	mv debian/tmp/usr/bin/gnatcoll_all2ada \
	   debian/tmp/usr/bin/gnatcoll_db2ada
install-%:
	gprinstall $(gpr_vars) \
	  gnatcoll_$*.gpr -XLIBRARY_TYPE=static \
	  $(static_GPRINSTALLFLAGS)
	gprinstall $(gpr_vars) \
	  gnatcoll_$*.gpr -XLIBRARY_TYPE=relocatable \
	  $(call shared_GPRINSTALLFLAGS,gnatcoll_$*)

override_dh_auto_build-indep:
  ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -Cdocs html latexpdf text $(DEB_BUILD_OPTION_PARALLEL:%=-j%)
  endif

# Avoid a warning about doc-main-package.
# Exclude generated sources from examples.
doc_pkg := libgnatcoll-db-doc
execute_before_dh_installdocs:
	dh_installdocs --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
execute_before_dh_installexamples:
	dh_installexamples --package=$(doc_pkg) --doc-main-package=$(doc_pkg) \
	  -Xgenerated

=== debian/watch ===
version=4

https://github.com/AdaCore/gnatcoll-db/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
